Bug 621774 - NFS 4 open(O_EXCL) is broken / also ESTALE on NFS 3
NFS 4 open(O_EXCL) is broken / also ESTALE on NFS 3
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
13
All Linux
low Severity medium
: ---
: ---
Assigned To: Kernel Maintainer List
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-08-06 01:49 EDT by Rudd-O DragonFear
Modified: 2011-06-28 10:55 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-06-28 10:55:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Rudd-O DragonFear 2010-08-06 01:49:52 EDT
Description of problem:

server has FUSE filesystem
server exports said FS through KNFSD
client mounts file system using NFS4
client cannot create new files with open(filename,O_EXCL) -- the syscall returns -EPERM but the file is created, mode 000.

client mounts file system using NFS3
if the file system is large enough, then eventually /usr/bin/find and other applications start experiencing ESTALE errors.


How reproducible:

Always


Steps to Reproduce:

Create a ZFS-FUSE file system
Export via NFS  

Mount said export in a client, fstype nfs4
Try to cp a file into it -- see it fail

Mount the same export with fstype nfs3
Ensure that the exported file system has LOTS of files (many thousands)
Do a couple finds in the mountpoint.  After a while you should start seeing Stale NFS file handle errors.

Now export a regular in-kernel file system and mount that on the client, either with nfs3 or nfs4.  That works flawlessly.  I tested ext4, ext2 and tmpfs.


Additional info:

This happens either with the Fedora kernels or kernel 2.6.35 vanilla, both in the client and in the server, or in any combination between both machines.
Comment 2 Bug Zapper 2011-06-01 08:02:10 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 3 Bug Zapper 2011-06-28 10:55:51 EDT
Fedora 13 changed to end-of-life (EOL) status on 2011-06-25. Fedora 13 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.